/*
	MarkovGen - A Markov Chain Program
	Copyright (C) 2012-2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ARGUMENTS_HPP
#define ARGUMENTS_HPP

#include <cstdint>
#include <argp.h>
#include <set>

class Arguments
{
	public:
		Arguments(int argc, char **argv);
		
		uint32_t min_match;
		uint32_t max_match;
		uint32_t min_generate;
		uint32_t max_generate;
		std::set<char> allow;
		std::set<char> filter;
		std::set<char> split;
		std::string post_char;
		std::string post_group;
		
	private:
		error_t Parse(int key, char *arg, struct argp_state *state);
		static error_t parser(int key, char *arg, struct argp_state *state);
		static uint32_t StringToInt(const char *arg, const struct argp_state *state, uint32_t min = 0, uint32_t max = 0xFFFFFFFF);
		
		static const struct argp s_argp;
		static const struct argp_option s_options[];
};

#endif
